unit LogDialog;

interface

uses Windows, Messages, NForm;

type
  TLogDlg = class(TModelessDlg)
    Buf: string;
    AppName: string;
    procedure Write(const S: string);
    procedure WMInitDialog(var Message: TWMInitDialog); message WM_INITDIALOG;
    procedure WMSize(var Message: TWMSize); message WM_SIZE;
    procedure WMCommand(var Message: TWMCommand); message WM_COMMAND;
  end;

implementation

const
  IDC_LOG = 100;

procedure TLogDlg.Write(const S: string);
const
  maxlen = 20000;
var
  len: Integer;
begin
  if Length(Buf) > maxlen then 
    Buf := Copy(Buf, Length(Buf)-maxlen div 2, maxlen div 2);
  Buf := Buf + S;

  if IsWindow(Handle) then
    with Items[IDC_LOG] do
    begin
      len := GetWindowTextLength(Handle);
      if len > maxlen then
      begin
        SendMsg(EM_SETSEL, 0, maxlen div 2);
        SendMsg(EM_REPLACESEL, 0, LParam(PChar('')));
        len := GetWindowTextLength(Handle);
      end;
      SendMsg(EM_SETSEL, len, len);
      SendMsg(EM_REPLACESEL, 0, LParam(PChar(S)));
    end;
end;

procedure TLogDlg.WMInitDialog(var Message: TWMInitDialog);
begin
  SetText(AppName + ' Log');
  with Items[IDC_LOG] do
  begin
    SetFocus(Handle);
    SetText(Buf);
    SendMsg(EM_LINESCROLL, 0, SendMsg(EM_GETLINECOUNT, 0, 0));
    SendMsg(EM_SETSEL, Length(Buf), Length(Buf));
  end;
  Message.Result := 0;
end;

procedure TLogDlg.WMSize(var Message: TWMSize);
var
  w, h: Integer;
begin
  GetClientSize(w, h);
  Items[IDC_LOG].SetBounds(0, 0, w, h);
end;

procedure TLogDlg.WMCommand(var Message: TWMCommand);
begin
  with Message do
    case ItemID of
      IDOK, IDCANCEL:
        begin
          Result := 1;
          Close;
        end;
    end;
end;

end.
